#include <oxstd.h>
#include <oxfloat.h>
#include <oxprob.h>
#include <oxdraw.h>
#import <maximize>

decl BO_FLAG=FALSE;	  // flag whether to compute power bound under power constraint on grid1

decl logh,swtch,LANtest,benchtest, Y, eps, epsdel;
decl deleps;

decl rho;
decl n;

decl level=0.05;
decl p_level;

decl PTswitchcv,filename;

decl seteps,mkY,setlogh,getLR0,getLR1,getpowerbench;

decl grid0,grid1,chkgrid0,chkgrid1,N0,N1,N,grid1alt,thaltlist,malt,fdellist,fblist,nalt,n0,b1s;

logprobn(const a0, const a1)
{
	return (a0.>0) .? (
			(a0.<30) .? log(tailn(a0)-tailn(a1)) .: -.5*sqr(a0)-.5*log(2*M_PI)+log(1 ./ a0 -exp(-.5*(sqr(a1)-sqr(a0)))./a1)
			) .:
			(													   
			(a1.>-30) .? log(probn(a1)-probn(a0)) .: -.5*sqr(a1)-.5*log(2*M_PI)+log(-1 ./ a1 +exp(.5*(sqr(a1)-sqr(a0)))./a0)
			);
}

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXX  PN: positive nuicance parameter XXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

decl Sigi;
setepsPN()
{
	eps=choleski((1~rho)|(rho~1))*rann(2,n);
	Sigi=invertsym((1~rho)|(rho~1));
	epsdel=ranu(1,n);
}

mkYPN(const thlist)
{
	Y=eps;
	decl m=columns(thlist);
	for(decl i=0;i<m;i++){
		decl del=thlist[0:1][i];
		Y[1][n*i/m:n*(i+1)/m-1]+=del[0]+(del[1]-del[0])*epsdel[n*i/m:n*(i+1)/m-1];
		Y[0][n*i/m:n*(i+1)/m-1]+=thlist[2][i];
	}
}

setloghPN()
{
	decl loghv=zeros(malt,n);
	for(decl i=0;i<malt;i++){
		decl del=thaltlist[0:1][i];
		decl Yx=Y;
		Yx[0][]-=thaltlist[2][i];
		decl delbarY=(Sigi[1][1]^(-1)*Sigi[1][])*Yx;
		decl a1=sqrt(Sigi[1][1])*(del[1]-delbarY);
		decl a0=sqrt(Sigi[1][1])*(del[0]-delbarY);
		loghv[i][]=-.5*sumc(Yx.*(Sigi*Yx))+(.5*Sigi[1][1])*sqr(delbarY)
					+logprobn(a0,a1)-log(del[1]-del[0]);
	}
	logh=maxc(loghv);
	logh+=log(meanc(exp(loghv-logh)));
	LANtest=benchtest=fabs(Y[0][]).>quann(1-level/2);
	swtch=(Y[1][].>PTswitchcv) .? -1E300+2E300*LANtest .:0;
//	swtch=(Y[1][].>-10) .? -1E100+2E100*(fabs(Y[0][]).>quann(1-level/2)) .:0;
}


getLR0PN(const del)
{
	decl delbarY=(Sigi[1][1]^(-1)*Sigi[1][])*Y;
	decl a1=sqrt(Sigi[1][1])*(del[1]-delbarY);
	decl a0=sqrt(Sigi[1][1])*(del[0]-delbarY);
	return -.5*sumc(Y.*(Sigi*Y))+(.5*Sigi[1][1])*sqr(delbarY)
			+logprobn(a0,a1)-log(del[1]-del[0]);

}

getLR1PN(const theta)
{
	decl Yx=Y;
	Yx[0][]-=theta[2];
	decl del=theta[0:1];
	decl delbarY=(Sigi[1][1]^(-1)*Sigi[1][])*Yx;
	decl a1=sqrt(Sigi[1][1])*(del[1]-delbarY);
	decl a0=sqrt(Sigi[1][1])*(del[0]-delbarY);
	return -.5*sumc(Yx.*(Sigi*Yx))+(.5*Sigi[1][1])*sqr(delbarY)
				+logprobn(a0,a1)-log(del[1]-del[0]);
}


getpowerbenchPN()
{
	return fabs(Y[0][]).>quann(0.975);
}

setupPN()
{
	decl stepsize=0.5;
	grid0=(0|.04)~(range(0,12,stepsize)|range(stepsize,12+stepsize,stepsize));//~(range(7,9,.1)|range(7.1,9.1,.1));

	chkgrid0=sortr(grid0[0][]~meanc(grid0));	
	chkgrid0|=chkgrid0+.01;
	stepsize=.5;
	grid1=9+(range(0,4,stepsize)|range(stepsize,4+stepsize,stepsize));
	b1s=<-2,2>;
	grid1=(grid1|b1s[0])~(grid1|b1s[1]);
	p_level=0.516;
	N0=columns(grid0);
	N1=columns(grid1);
	N=N0+N1;
	grid1alt=new array[N1];
	for(decl i=0;i<N1;i++)
		grid1alt[i]=grid1[][i];


	thaltlist=<0,0;9,9>|b1s;
	malt=columns(thaltlist);

	fdellist=range(0,60)'/4;
	fdellist~=fdellist+.01;
	fblist=<-1;-2;-3;-4;0;1;2;3;4>;

	nalt=100000;
	n0=20000;

	PTswitchcv=6;

	seteps=setepsPN;mkY=mkYPN;setlogh=setloghPN;getLR0=getLR0PN;getLR1=getLR1PN;getpowerbench=getpowerbenchPN;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXX  IM: Imbens and Manski  XXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

setepsIM()
{
	eps=rann(2,n);
	deleps=ranu(1,n);
}


mkYIM(const thlist)
{
	Y=eps[0][]|(rho*eps[0][]+(sqrt(1-rho^2))*eps[1][]);
	decl m=columns(thlist);
	for(decl i=0;i<m;i++){
		decl theta=thlist[][i];
		if(theta[2]>=0){
			Y[0][n*i/m:n*(i+1)/m-1]+=theta[2];
			Y[1][n*i/m:n*(i+1)/m-1]+=theta[2]+theta[0]+(theta[1]-theta[0])*deleps[n*i/m:n*(i+1)/m-1];
			}
		else{
			Y[0][n*i/m:n*(i+1)/m-1]+=theta[2]-(theta[0]+(theta[1]-theta[0])*deleps[n*i/m:n*(i+1)/m-1]);
			Y[1][n*i/m:n*(i+1)/m-1]+=theta[2];
		}	
	}		
}

setloghIM()
{
	Sigi=invertsym((1~rho)|(rho~1));

	decl loghv=zeros(2*malt,n);
	for(decl i=0;i<malt;i++){
		decl del=thaltlist[0:1][i];
	
		decl Yx=Y-thaltlist[2][i];
		decl delbarY=(Sigi[1][1]^(-1)*Sigi[1][])*Yx;
		decl a1=sqrt(Sigi[1][1])*(del[1]-delbarY);
		decl a0=sqrt(Sigi[1][1])*(del[0]-delbarY);
		loghv[i][]=-.5*sumc(Yx.*(Sigi*Yx))+(.5*Sigi[1][1])*sqr(delbarY)
					+logprobn(a0,a1)-log(del[1]-del[0]);

		Yx=Y+thaltlist[2][i];
		delbarY=-(Sigi[0][0]^(-1)*Sigi[0][])*Yx;
		a1=sqrt(Sigi[0][0])*(del[1]-delbarY);
		a0=sqrt(Sigi[0][0])*(del[0]-delbarY);
		loghv[malt+i][]=-.5*sumc(Yx.*(Sigi*Yx))+(.5*Sigi[0][0])*sqr(delbarY)
					+logprobn(a0,a1)-log(del[1]-del[0]);
 	}
	logh=maxc(loghv);
	logh+=log(meanc(exp(loghv-logh)));
	LANtest=(Y[0][].>quann(1-level)) .|| (-Y[1][].>quann(1-level));
	swtch=((Y[1][]-Y[0][]).>PTswitchcv) .? -1E300+2E300*LANtest .:0;
}

getLR1IM(const theta)
{
	decl del=theta[0:1];
	decl g=zeros(2,n);
	decl Yx=Y-theta[2];
	decl delbarY=(Sigi[1][1]^(-1)*Sigi[1][])*Yx;
	decl a1=sqrt(Sigi[1][1])*(del[1]-delbarY);
	decl a0=sqrt(Sigi[1][1])*(del[0]-delbarY);
	g[0][]=-.5*sumc(Yx.*(Sigi*Yx))+(.5*Sigi[1][1])*sqr(delbarY)
				+logprobn(a0,a1)-log(del[1]-del[0]);

	Yx=Y+theta[2];
	delbarY=-(Sigi[0][0]^(-1)*Sigi[0][])*Yx;
	a1=sqrt(Sigi[0][0])*(del[1]-delbarY);
	a0=sqrt(Sigi[0][0])*(del[0]-delbarY);
	g[1][]=-.5*sumc(Yx.*(Sigi*Yx))+(.5*Sigi[0][0])*sqr(delbarY)
				+logprobn(a0,a1)-log(del[1]-del[0]);
	decl gmax=maxc(g);
	return gmax+log(meanc(exp(g-gmax)));
}

getLR0IM(const theta)
{
	decl del=theta[0:1];
	decl g=zeros(2,n);
	decl delbarY=(Sigi[1][1]^(-1)*Sigi[1][])*Y;
	decl a1=sqrt(Sigi[1][1])*(del[1]-delbarY);
	decl a0=sqrt(Sigi[1][1])*(del[0]-delbarY);
	g[0][]=-.5*sumc(Y.*(Sigi*Y))+(.5*Sigi[1][1])*sqr(delbarY)
			+logprobn(a0,a1)-log(del[1]-del[0]);

	delbarY=-(Sigi[0][0]^(-1)*Sigi[0][])*Y;
	a1=sqrt(Sigi[0][0])*(del[1]-delbarY);
	a0=sqrt(Sigi[0][0])*(del[0]-delbarY);
	g[1][]=	-.5*sumc(Y.*(Sigi*Y))+(.5*Sigi[0][0])*sqr(delbarY)
			+logprobn(a0,a1)-log(del[1]-del[0])
			;
	decl gmax=maxc(g);
	return gmax+log(meanc(exp(g-gmax)));
}


getpowerbenchIM()
{
	return (Y[0][].>quann(0.975)) .|| (Y[1][].<-quann(0.975));
}

setupIM()
{
	PTswitchcv=6;

	thaltlist=<	0,9,2>';
	malt=columns(thaltlist);

	grid0=(0|.1)~((range(0,25)/2)|(range(1,26)/2));
	chkgrid0=sortr(grid0[0][]~meanc(grid0));
	chkgrid0|=chkgrid0+.01;

	p_level=tailn(1.645-2);

	grid1=range(9,12,.25);
	grid1|=(grid1+.25)|2;
	N1=columns(grid1);
	grid1alt=new array[N1];
	for(decl i=0;i<N1;i++)
		grid1alt[i]=grid1[][i];
	fdellist=range(0,32)'/4;
	fdellist~=fdellist+.01;
	fblist=<0;1;2;3;4>;
	nalt=100000;
	n0=20000;

	seteps=setepsIM;mkY=mkYIM;setlogh=setloghIM;getLR0=getLR0IM;getLR1=getLR1IM;getpowerbench=getpowerbenchIM;
}

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXX  BF: Behrens Fisher XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

decl nx,ny,nt;
decl GQuadxw, nQuad=10;
setepsBF()
{
	eps=(rann(1,n)/sqrt(ny))|(sqrt(ranchi(1,n,ny-1)/(ny-1)))|(rann(1,n)/sqrt(nx))|sqrt(ranchi(1,n,nx-1)/(nx-1));
	deleps=ranu(1,n);
}

mkYBF(const theta)
{
	decl thlist;
	if(theta[2][0]!=0) 	thlist=theta~(theta[0:1][]|(-theta[2][]));
		else thlist=theta;
	if(nx==ny) thlist=thlist~((-reversec(thlist[0:1][])|thlist[2][]));

	decl m=columns(thlist);
	Y=zeros(2,n);
	for(decl i=0;i<m;i++){
		decl del=thlist[0][i]+(thlist[1][i]-thlist[0][i])*deleps[0][n*i/m:n*(i+1)/m-1];
		decl b=thlist[2][i]*sqrt(1/nx+exp(2*del)/ny);
		Y[][n*i/m:n*(i+1)/m-1]=((b+exp(del).*eps[0][n*i/m:n*(i+1)/m-1]-eps[2][n*i/m:n*(i+1)/m-1])./eps[3][n*i/m:n*(i+1)/m-1])
						|(exp(del).*eps[1][n*i/m:n*(i+1)/m-1]./eps[3][n*i/m:n*(i+1)/m-1]);
	}
}

setloghBF()
{
	decl thaltlist2=thaltlist~(thaltlist[0:1][]|(-thaltlist[2][]));
	if(nx==ny) thaltlist2=thaltlist2~((-reversec(thaltlist2[0:1][])|thaltlist2[2][]));
	decl malt=columns(thaltlist2);
	decl loghv=zeros(malt,n);
	for(decl i=0;i<malt;i++){

		decl dels=thaltlist2[0:1][i];
		decl fs=zeros(nQuad,n);
		for(decl iQuad=0;iQuad<nQuad;iQuad++){

			decl del=dels[0]+GQuadxw[iQuad][0]*(dels[1]-dels[0]);
			decl b=thaltlist2[2][i]*sqrt(1/nx+exp(2*del)/ny);
			
			decl om=exp(del);
			decl den=nx*sqr(om)+ny;
			decl c=sqrt(
				(sqr(ny*Y[1][])+nx*sqr(om)*((nx-1)*sqr(om)-sqr(Y[1][]))+ny*(-sqr(Y[1][])+sqr(om)*(-1+nx*(1+sumsqrc(Y)))))
				/(sqr(om)*den)
				);
			decl d=(nx*ny*b/den)*Y[0][];
			decl g;

			switch_single(nt){

				case 1: g=(c + d .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./c.^3;
				case 2: g= 
				  (c .* d + (c.^2 + d.^2) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./c.^5;
				case 3: g= 
				  (c .* (2 .* c.^2 + d.^2) + d .* (3 .* c.^2 + d.^2) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./c.^7;
				case 4: g= 
				  (c .* d .* (5 .* c.^2 + d.^2) + (3 .* c.^4 + 6 .* c.^2 .* d.^2 + d.^4) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./c.^9;
				case 5: g= 
				  (c .* (8 .* c.^4 + 9 .* c.^2 .* d.^2 + d.^4) + d .* (15 .* c.^4 + 10 .* c.^2 .* d.^2 + d.^4) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* 
				     probn(d./c))./c.^11;
				case 6: g= (c .* d .* (33 .* c.^4 + 14 .* c.^2 .* d.^2 + d.^4) + (15 .* c.^6 + 45 .* c.^4 .* d.^2 + 15 .* c.^2 .* d.^4 + d.^6) .* 
				     exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./c.^13;
				case 7: g= 
				  (c .* (48 .* c.^6 + 87 .* c.^4 .* d.^2 + 20 .* c.^2 .* d.^4 + d.^6) + d .* (105 .* c.^6 + 105 .* c.^4 .* d.^2 + 21 .* c.^2 .* d.^4 + d.^6) .* 
				     exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./c.^15;
				case 8: g= 
				  (c .* d .* (279 .* c.^6 + 185 .* c.^4 .* d.^2 + 27 .* c.^2 .* d.^4 + d.^6) + 
				    (105 .* c.^8 + 420 .* c.^6 .* d.^2 + 210 .* c.^4 .* d.^4 + 28 .* c.^2 .* d.^6 + d.^8) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./
				   c.^17;
				case 9: g= (c .* (384 .* c.^8 + 975 .* c.^6 .* d.^2 + 345 .* c.^4 .* d.^4 + 35 .* c.^2 .* d.^6 + d.^8) + 
				    d .* (945 .* c.^8 + 1260 .* c.^6 .* d.^2 + 378 .* c.^4 .* d.^4 + 36 .* c.^2 .* d.^6 + d.^8) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* 
				     probn(d./c))./c.^19;
				case 10: g= (c .* d .* (2895 .* c.^8 + 2640 .* c.^6 .* d.^2 + 588 .* c.^4 .* d.^4 + 44 .* c.^2 .* d.^6 + d.^8) + 
				    (945 .* c.^10 + 4725 .* c.^8 .* d.^2 + 3150 .* c.^6 .* d.^4 + 630 .* c.^4 .* d.^6 + 45 .* c.^2 .* d.^8 + d.^10) .* exp(sqr(d)./(2 .* sqr(c))) .* 
				     sqrt(M_2PI) .* probn(d./c))./c.^21;
				case 11: g= 
				  (1 ./c.^23) .* (c .* (3840 .* c.^10 + 12645 .* c.^8 .* d.^2 + 6090 .* c.^6 .* d.^4 + 938 .* c.^4 .* d.^6 + 54 .* c.^2 .* d.^8 + d.^10) + 
				    d .* (10395 .* c.^10 + 17325 .* c.^8 .* d.^2 + 6930 .* c.^6 .* d.^4 + 990 .* c.^4 .* d.^6 + 55 .* c.^2 .* d.^8 + d.^10) .* exp(sqr(d)./(2 .* sqr(c))) .* 
				     sqrt(M_2PI) .* probn(d./c));
				case 12: g= 
				  (1 ./c.^25) .* (c .* d .* (35685 .* c.^10 + 41685 .* c.^8 .* d.^2 + 12558 .* c.^6 .* d.^4 + 1422 .* c.^4 .* d.^6 + 65 .* c.^2 .* d.^8 + d.^10) + 
				    (10395 .* c.^12 + 62370 .* c.^10 .* d.^2 + 51975 .* c.^8 .* d.^4 + 13860 .* c.^6 .* d.^6 + 1485 .* c.^4 .* d.^8 + 66 .* c.^2 .* d.^10 + 
				      d.^12) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c));
				case 13: g= 
				  (1 ./c.^27) .* (c .* (46080 .* c.^12 + 187425 .* c.^10 .* d.^2 + 114765 .* c.^8 .* d.^4 + 23814 .* c.^6 .* d.^6 + 2070 .* c.^4 .* d.^8 + 
				      77 .* c.^2 .* d.^10 + d.^12) + d .* (135135 .* c.^12 + 270270 .* c.^10 .* d.^2 + 135135 .* c.^8 .* d.^4 + 25740 .* c.^6 .* d.^6 + 
				      2145 .* c.^4 .* d.^8 + 78 .* c.^2 .* d.^10 + d.^12) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c));
				case 14: g= 
				  (1 ./(sqrt(2) .* c.^29)) .* (sqrt(2) .* c .* (509985 .* c.^12 .* d + 729330 .* c.^10 .* d.^3 + 278019 .* c.^8 .* d.^5 + 42300 .* c.^6 .* d.^7 + 
				      2915 .* c.^4 .* d.^9 + 90 .* c.^2 .* d.^11 + d.^13) + 2 .* (135135 .* c.^14 + 945945 .* c.^12 .* d.^2 + 945945 .* c.^10 .* d.^4 + 
				      315315 .* c.^8 .* d.^6 + 45045 .* c.^6 .* d.^8 + 3003 .* c.^4 .* d.^10 + 91 .* c.^2 .* d.^12 + d.^14) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_PI) .* 
				     probn(d./c));
				case 15: g= (1 ./(sqrt(2) .* c.^31)) .* (sqrt(2) .* c .* (645120 .* c.^14 + 3133935 .* c.^12 .* d.^2 + 2336040 .* c.^10 .* d.^4 + 
				      611415 .* c.^8 .* d.^6 + 71280 .* c.^6 .* d.^8 + 3993 .* c.^4 .* d.^10 + 104 .* c.^2 .* d.^12 + d.^14) + 
				    2 .* d .* (2027025 .* c.^14 + 4729725 .* c.^12 .* d.^2 + 2837835 .* c.^10 .* d.^4 + 675675 .* c.^8 .* d.^6 + 75075 .* c.^6 .* d.^8 + 
				      4095 .* c.^4 .* d.^10 + 105 .* c.^2 .* d.^12 + d.^14) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_PI) .* probn(d./c));
				case 16: g= 
				  (1 ./(sqrt(2) .* c.^33)) .* (sqrt(2) .* c .* d .* (8294895 .* c.^14 + 14073885 .* c.^12 .* d.^2 + 6506325 .* c.^10 .* d.^4 + 
				      1245915 .* c.^8 .* d.^6 + 115005 .* c.^6 .* d.^8 + 5343 .* c.^4 .* d.^10 + 119 .* c.^2 .* d.^12 + d.^14) + 
				    2 .* (2027025 .* c.^16 + 16216200 .* c.^14 .* d.^2 + 18918900 .* c.^12 .* d.^4 + 7567560 .* c.^10 .* d.^6 + 1351350 .* c.^8 .* d.^8 + 
				      120120 .* c.^6 .* d.^10 + 5460 .* c.^4 .* d.^12 + 120 .* c.^2 .* d.^14 + d.^16) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_PI) .* probn(d./c));
				case 17: g= 
				  (1 ./(sqrt(2) .* c.^35)) .* (sqrt(2) .* c .* (10321920 .* c.^16 + 58437855 .* c.^14 .* d.^2 + 51450525 .* c.^12 .* d.^4 + 
				      16288965 .* c.^10 .* d.^6 + 2386395 .* c.^8 .* d.^8 + 178893 .* c.^6 .* d.^10 + 7007 .* c.^4 .* d.^12 + 135 .* c.^2 .* d.^14 + 
				      d.^16) + 2 .* d .* (34459425 .* c.^16 + 91891800 .* c.^14 .* d.^2 + 64324260 .* c.^12 .* d.^4 + 18378360 .* c.^10 .* d.^6 + 
				      2552550 .* c.^8 .* d.^8 + 185640 .* c.^6 .* d.^10 + 7140 .* c.^4 .* d.^12 + 136 .* c.^2 .* d.^14 + d.^16) .* exp(sqr(d)./(2 .* sqr(c))) .* 
				     sqrt(M_PI) .* probn(d./c));
				case 18: g= (1 ./(sqrt(2) .* c.^37)) .* 
				   (sqrt(2) .* c .* d .* (151335135 .* c.^16 + 297693900 .* c.^14 .* d.^2 + 162058050 .* c.^12 .* d.^4 + 37469520 .* c.^10 .* d.^6 + 
				      4341480 .* c.^8 .* d.^8 + 269724 .* c.^6 .* d.^10 + 9030 .* c.^4 .* d.^12 + 152 .* c.^2 .* d.^14 + d.^16) + 
				    2 .* (34459425 .* c.^18 + 310134825 .* c.^16 .* d.^2 + 413513100 .* c.^14 .* d.^4 + 192972780 .* c.^12 .* d.^6 + 
				      41351310 .* c.^10 .* d.^8 + 4594590 .* c.^8 .* d.^10 + 278460 .* c.^6 .* d.^12 + 9180 .* c.^4 .* d.^14 + 153 .* c.^2 .* d.^16 + d.^18) .* 
				     exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_PI) .* probn(d./c));
				case 19: g= (1 ./(sqrt(2) .* c.^39)) .* 
				   (sqrt(2) .* c .* (185794560 .* c.^18 + 1203216525 .* c.^16 .* d.^2 + 1223803350 .* c.^14 .* d.^4 + 455259420 .* c.^12 .* d.^6 + 
				      80424630 .* c.^10 .* d.^8 + 7561554 .* c.^8 .* d.^10 + 395850 .* c.^6 .* d.^12 + 11460 .* c.^4 .* d.^14 + 170 .* c.^2 .* d.^16 + 
				      d.^18) + 2 .* d .* (654729075 .* c.^18 + 1964187225 .* c.^16 .* d.^2 + 1571349780 .* c.^14 .* d.^4 + 
				      523783260 .* c.^12 .* d.^6 + 87297210 .* c.^10 .* d.^8 + 7936110 .* c.^8 .* d.^10 + 406980 .* c.^6 .* d.^12 + 
				      11628 .* c.^4 .* d.^14 + 171 .* c.^2 .* d.^16 + d.^18) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_PI) .* probn(d./c));
				case 20: g= 
				  (1 ./(sqrt(2) .* c.^41)) .* (sqrt(2) .* c .* d .* (3061162125 .* c.^18 + 6859400625 .* c.^16 .* d.^2 + 4302906300 .* c.^14 .* d.^4 + 
				      1167180300 .* c.^12 .* d.^6 + 162912750 .* c.^10 .* d.^8 + 12686310 .* c.^8 .* d.^10 + 567420 .* c.^6 .* d.^12 + 
				      14348 .* c.^4 .* d.^14 + 189 .* c.^2 .* d.^16 + d.^18) + 2 .* (654729075 .* c.^20 + 6547290750 .* c.^18 .* d.^2 + 
				      9820936125 .* c.^16 .* d.^4 + 5237832600 .* c.^14 .* d.^6 + 1309458150 .* c.^12 .* d.^8 + 174594420 .* c.^10 .* d.^10 + 
				      13226850 .* c.^8 .* d.^12 + 581400 .* c.^6 .* d.^14 + 14535 .* c.^4 .* d.^16 + 190 .* c.^2 .* d.^18 + d.^20) .* exp(sqr(d)./(2 .* sqr(c))) .* 
				     sqrt(M_PI) .* probn(d./c));
				}

			g=setbounds(g,1E-300,1E300);
			fs[iQuad][]=(ny-2)*(log(Y[1][]))-(ny-1)*log(om)-.5*log(den)-.5*b^2*nx*ny/den+log(g);
		}
		decl mfs=maxc(fs);
		loghv[i][]=mfs+log(GQuadxw[][1]'exp(fs-mfs));
		
	}
	logh=maxc(loghv);
	logh+=log(meanc(exp(loghv-logh)));	
	decl t= 1 ./ sqrt( (1/nx) ./ sqr(Y[0][]) + (sqr(Y[1][])/ny) ./ sqr(Y[0][]));
	LANtest=(log(Y[1][]).>0) .? (t.>quant(1-level/2,ny-1)) .: (t.>quant(1-level/2,nx-1) );
	swtch=(fabs(log(Y[1][])).>PTswitchcv) .? -1E300+2E300*LANtest .:0;
}

getLR1BF(const theta)
{
	decl thlist=theta~(theta[0:1][]|(-theta[2][]));
	if(nx==ny) thlist=thlist~((-reversec(thlist[0:1][])|thlist[2][]));
	decl g=zeros(columns(thlist),n);
	for(decl i=0;i<columns(thlist);i++){

		decl dels=thlist[0:1][i];
		decl fs=zeros(nQuad,n);
		for(decl iQuad=0;iQuad<nQuad;iQuad++){

			decl del=dels[0]+GQuadxw[iQuad][0]*(dels[1]-dels[0]);
			decl b=thlist[2][i]*sqrt(1/nx+exp(2*del)/ny);
			
			decl om=exp(del);
			decl den=nx*sqr(om)+ny;
			decl c=sqrt(
				(sqr(ny*Y[1][])+nx*sqr(om)*((nx-1)*sqr(om)-sqr(Y[1][]))+ny*(-sqr(Y[1][])+sqr(om)*(-1+nx*(1+sumsqrc(Y)))))
				/(sqr(om)*den)
				);
			decl d=(nx*ny*b/den)*Y[0][];
			decl g;
			switch_single(nt){

				case 1: g=(c + d .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./c.^3;
				case 2: g= 
				  (c .* d + (c.^2 + d.^2) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./c.^5;
				case 3: g= 
				  (c .* (2 .* c.^2 + d.^2) + d .* (3 .* c.^2 + d.^2) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./c.^7;
				case 4: g= 
				  (c .* d .* (5 .* c.^2 + d.^2) + (3 .* c.^4 + 6 .* c.^2 .* d.^2 + d.^4) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./c.^9;
				case 5: g= 
				  (c .* (8 .* c.^4 + 9 .* c.^2 .* d.^2 + d.^4) + d .* (15 .* c.^4 + 10 .* c.^2 .* d.^2 + d.^4) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* 
				     probn(d./c))./c.^11;
				case 6: g= (c .* d .* (33 .* c.^4 + 14 .* c.^2 .* d.^2 + d.^4) + (15 .* c.^6 + 45 .* c.^4 .* d.^2 + 15 .* c.^2 .* d.^4 + d.^6) .* 
				     exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./c.^13;
				case 7: g= 
				  (c .* (48 .* c.^6 + 87 .* c.^4 .* d.^2 + 20 .* c.^2 .* d.^4 + d.^6) + d .* (105 .* c.^6 + 105 .* c.^4 .* d.^2 + 21 .* c.^2 .* d.^4 + d.^6) .* 
				     exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./c.^15;
				case 8: g= 
				  (c .* d .* (279 .* c.^6 + 185 .* c.^4 .* d.^2 + 27 .* c.^2 .* d.^4 + d.^6) + 
				    (105 .* c.^8 + 420 .* c.^6 .* d.^2 + 210 .* c.^4 .* d.^4 + 28 .* c.^2 .* d.^6 + d.^8) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c))./
				   c.^17;
				case 9: g= (c .* (384 .* c.^8 + 975 .* c.^6 .* d.^2 + 345 .* c.^4 .* d.^4 + 35 .* c.^2 .* d.^6 + d.^8) + 
				    d .* (945 .* c.^8 + 1260 .* c.^6 .* d.^2 + 378 .* c.^4 .* d.^4 + 36 .* c.^2 .* d.^6 + d.^8) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* 
				     probn(d./c))./c.^19;
				case 10: g= (c .* d .* (2895 .* c.^8 + 2640 .* c.^6 .* d.^2 + 588 .* c.^4 .* d.^4 + 44 .* c.^2 .* d.^6 + d.^8) + 
				    (945 .* c.^10 + 4725 .* c.^8 .* d.^2 + 3150 .* c.^6 .* d.^4 + 630 .* c.^4 .* d.^6 + 45 .* c.^2 .* d.^8 + d.^10) .* exp(sqr(d)./(2 .* sqr(c))) .* 
				     sqrt(M_2PI) .* probn(d./c))./c.^21;
				case 11: g= 
				  (1 ./c.^23) .* (c .* (3840 .* c.^10 + 12645 .* c.^8 .* d.^2 + 6090 .* c.^6 .* d.^4 + 938 .* c.^4 .* d.^6 + 54 .* c.^2 .* d.^8 + d.^10) + 
				    d .* (10395 .* c.^10 + 17325 .* c.^8 .* d.^2 + 6930 .* c.^6 .* d.^4 + 990 .* c.^4 .* d.^6 + 55 .* c.^2 .* d.^8 + d.^10) .* exp(sqr(d)./(2 .* sqr(c))) .* 
				     sqrt(M_2PI) .* probn(d./c));
				case 12: g= 
				  (1 ./c.^25) .* (c .* d .* (35685 .* c.^10 + 41685 .* c.^8 .* d.^2 + 12558 .* c.^6 .* d.^4 + 1422 .* c.^4 .* d.^6 + 65 .* c.^2 .* d.^8 + d.^10) + 
				    (10395 .* c.^12 + 62370 .* c.^10 .* d.^2 + 51975 .* c.^8 .* d.^4 + 13860 .* c.^6 .* d.^6 + 1485 .* c.^4 .* d.^8 + 66 .* c.^2 .* d.^10 + 
				      d.^12) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c));
				case 13: g= 
				  (1 ./c.^27) .* (c .* (46080 .* c.^12 + 187425 .* c.^10 .* d.^2 + 114765 .* c.^8 .* d.^4 + 23814 .* c.^6 .* d.^6 + 2070 .* c.^4 .* d.^8 + 
				      77 .* c.^2 .* d.^10 + d.^12) + d .* (135135 .* c.^12 + 270270 .* c.^10 .* d.^2 + 135135 .* c.^8 .* d.^4 + 25740 .* c.^6 .* d.^6 + 
				      2145 .* c.^4 .* d.^8 + 78 .* c.^2 .* d.^10 + d.^12) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_2PI) .* probn(d./c));
				case 14: g= 
				  (1 ./(sqrt(2) .* c.^29)) .* (sqrt(2) .* c .* (509985 .* c.^12 .* d + 729330 .* c.^10 .* d.^3 + 278019 .* c.^8 .* d.^5 + 42300 .* c.^6 .* d.^7 + 
				      2915 .* c.^4 .* d.^9 + 90 .* c.^2 .* d.^11 + d.^13) + 2 .* (135135 .* c.^14 + 945945 .* c.^12 .* d.^2 + 945945 .* c.^10 .* d.^4 + 
				      315315 .* c.^8 .* d.^6 + 45045 .* c.^6 .* d.^8 + 3003 .* c.^4 .* d.^10 + 91 .* c.^2 .* d.^12 + d.^14) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_PI) .* 
				     probn(d./c));
				case 15: g= (1 ./(sqrt(2) .* c.^31)) .* (sqrt(2) .* c .* (645120 .* c.^14 + 3133935 .* c.^12 .* d.^2 + 2336040 .* c.^10 .* d.^4 + 
				      611415 .* c.^8 .* d.^6 + 71280 .* c.^6 .* d.^8 + 3993 .* c.^4 .* d.^10 + 104 .* c.^2 .* d.^12 + d.^14) + 
				    2 .* d .* (2027025 .* c.^14 + 4729725 .* c.^12 .* d.^2 + 2837835 .* c.^10 .* d.^4 + 675675 .* c.^8 .* d.^6 + 75075 .* c.^6 .* d.^8 + 
				      4095 .* c.^4 .* d.^10 + 105 .* c.^2 .* d.^12 + d.^14) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_PI) .* probn(d./c));
				case 16: g= 
				  (1 ./(sqrt(2) .* c.^33)) .* (sqrt(2) .* c .* d .* (8294895 .* c.^14 + 14073885 .* c.^12 .* d.^2 + 6506325 .* c.^10 .* d.^4 + 
				      1245915 .* c.^8 .* d.^6 + 115005 .* c.^6 .* d.^8 + 5343 .* c.^4 .* d.^10 + 119 .* c.^2 .* d.^12 + d.^14) + 
				    2 .* (2027025 .* c.^16 + 16216200 .* c.^14 .* d.^2 + 18918900 .* c.^12 .* d.^4 + 7567560 .* c.^10 .* d.^6 + 1351350 .* c.^8 .* d.^8 + 
				      120120 .* c.^6 .* d.^10 + 5460 .* c.^4 .* d.^12 + 120 .* c.^2 .* d.^14 + d.^16) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_PI) .* probn(d./c));
				case 17: g= 
				  (1 ./(sqrt(2) .* c.^35)) .* (sqrt(2) .* c .* (10321920 .* c.^16 + 58437855 .* c.^14 .* d.^2 + 51450525 .* c.^12 .* d.^4 + 
				      16288965 .* c.^10 .* d.^6 + 2386395 .* c.^8 .* d.^8 + 178893 .* c.^6 .* d.^10 + 7007 .* c.^4 .* d.^12 + 135 .* c.^2 .* d.^14 + 
				      d.^16) + 2 .* d .* (34459425 .* c.^16 + 91891800 .* c.^14 .* d.^2 + 64324260 .* c.^12 .* d.^4 + 18378360 .* c.^10 .* d.^6 + 
				      2552550 .* c.^8 .* d.^8 + 185640 .* c.^6 .* d.^10 + 7140 .* c.^4 .* d.^12 + 136 .* c.^2 .* d.^14 + d.^16) .* exp(sqr(d)./(2 .* sqr(c))) .* 
				     sqrt(M_PI) .* probn(d./c));
				case 18: g= (1 ./(sqrt(2) .* c.^37)) .* 
				   (sqrt(2) .* c .* d .* (151335135 .* c.^16 + 297693900 .* c.^14 .* d.^2 + 162058050 .* c.^12 .* d.^4 + 37469520 .* c.^10 .* d.^6 + 
				      4341480 .* c.^8 .* d.^8 + 269724 .* c.^6 .* d.^10 + 9030 .* c.^4 .* d.^12 + 152 .* c.^2 .* d.^14 + d.^16) + 
				    2 .* (34459425 .* c.^18 + 310134825 .* c.^16 .* d.^2 + 413513100 .* c.^14 .* d.^4 + 192972780 .* c.^12 .* d.^6 + 
				      41351310 .* c.^10 .* d.^8 + 4594590 .* c.^8 .* d.^10 + 278460 .* c.^6 .* d.^12 + 9180 .* c.^4 .* d.^14 + 153 .* c.^2 .* d.^16 + d.^18) .* 
				     exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_PI) .* probn(d./c));
				case 19: g= (1 ./(sqrt(2) .* c.^39)) .* 
				   (sqrt(2) .* c .* (185794560 .* c.^18 + 1203216525 .* c.^16 .* d.^2 + 1223803350 .* c.^14 .* d.^4 + 455259420 .* c.^12 .* d.^6 + 
				      80424630 .* c.^10 .* d.^8 + 7561554 .* c.^8 .* d.^10 + 395850 .* c.^6 .* d.^12 + 11460 .* c.^4 .* d.^14 + 170 .* c.^2 .* d.^16 + 
				      d.^18) + 2 .* d .* (654729075 .* c.^18 + 1964187225 .* c.^16 .* d.^2 + 1571349780 .* c.^14 .* d.^4 + 
				      523783260 .* c.^12 .* d.^6 + 87297210 .* c.^10 .* d.^8 + 7936110 .* c.^8 .* d.^10 + 406980 .* c.^6 .* d.^12 + 
				      11628 .* c.^4 .* d.^14 + 171 .* c.^2 .* d.^16 + d.^18) .* exp(sqr(d)./(2 .* sqr(c))) .* sqrt(M_PI) .* probn(d./c));
				case 20: g= 
				  (1 ./(sqrt(2) .* c.^41)) .* (sqrt(2) .* c .* d .* (3061162125 .* c.^18 + 6859400625 .* c.^16 .* d.^2 + 4302906300 .* c.^14 .* d.^4 + 
				      1167180300 .* c.^12 .* d.^6 + 162912750 .* c.^10 .* d.^8 + 12686310 .* c.^8 .* d.^10 + 567420 .* c.^6 .* d.^12 + 
				      14348 .* c.^4 .* d.^14 + 189 .* c.^2 .* d.^16 + d.^18) + 2 .* (654729075 .* c.^20 + 6547290750 .* c.^18 .* d.^2 + 
				      9820936125 .* c.^16 .* d.^4 + 5237832600 .* c.^14 .* d.^6 + 1309458150 .* c.^12 .* d.^8 + 174594420 .* c.^10 .* d.^10 + 
				      13226850 .* c.^8 .* d.^12 + 581400 .* c.^6 .* d.^14 + 14535 .* c.^4 .* d.^16 + 190 .* c.^2 .* d.^18 + d.^20) .* exp(sqr(d)./(2 .* sqr(c))) .* 
				     sqrt(M_PI) .* probn(d./c));
				}
			g=setbounds(g,1E-300,1E300);
			fs[iQuad][]=(ny-2)*(log(Y[1][]))-(ny-1)*log(om)-.5*log(den)-.5*b^2*nx*ny/den+log(g);
		}
		decl mfs=maxc(fs);
		g[i][]=mfs+log(GQuadxw[][1]'exp(fs-mfs));
	
	}
	decl gmax=maxc(g);
	return gmax+log(meanc(exp(g-gmax)));
}

getLR0BF(const theta)
{
	decl dels=theta;
	decl fs=zeros(nQuad,n);
	decl g=zeros(1+(nx==ny),n);
	for(decl iQuad=0;iQuad<nQuad;iQuad++){

		decl del=dels[0]+GQuadxw[iQuad][0]*(dels[1]-dels[0]);
		decl om=exp(del);
		decl den=nx*sqr(om)+ny;
		decl c=sqrt(
			(sqr(ny*Y[1][])+nx*sqr(om)*((nx-1)*sqr(om)-sqr(Y[1][]))+ny*(-sqr(Y[1][])+sqr(om)*(-1+nx*(1+sumsqrc(Y)))))
			/(sqr(om)*den)
			);

		fs[iQuad][]=(ny-2)*(log(Y[1][]))-(ny-1)*log(om)-.5*log(den)-(nt+1)*log(c)+.5*(nt-1)*log(2)+loggamma(.5*(nt+1));
	}
	decl mfs=maxc(fs);
	g[0][]=mfs+log(GQuadxw[][1]'exp(fs-mfs));
	if(nx==ny){
		dels=-reversec(dels);
		for(decl iQuad=0;iQuad<nQuad;iQuad++){

			decl del=dels[0]+GQuadxw[iQuad][0]*(dels[1]-dels[0]);
			decl om=exp(del);
			decl den=nx*sqr(om)+ny;
			decl c=sqrt(
				(sqr(ny*Y[1][])+nx*sqr(om)*((nx-1)*sqr(om)-sqr(Y[1][]))+ny*(-sqr(Y[1][])+sqr(om)*(-1+nx*(1+sumsqrc(Y)))))
				/(sqr(om)*den)
				);

			fs[iQuad][]=(ny-2)*(log(Y[1][]))-(ny-1)*log(om)-.5*log(den)-(nt+1)*log(c)+.5*(nt-1)*log(2)+loggamma(.5*(nt+1));
		}
		decl mfs=maxc(fs);
		g[1][]=mfs+log(GQuadxw[][1]'exp(fs-mfs));
	}
	decl gmax=maxc(g);
	return gmax+log(meanc(exp(g-gmax)));
}

getpowerbenchBF()
{
	decl t= 1 ./ sqrt( (1/nx) ./ sqr(Y[0][]) + (sqr(Y[1][])/ny) ./ sqr(Y[0][]));
	return t.>quant(0.975,min(nx,ny)-1);

}

setupBF()
{
//	Gaussian quadrature weights
	GQuadxw=loadmat(sprint("quadw",nQuad,".dat"));

	if(rho>1) {rho=round(rho); nx=idiv(rho,1000); ny=imod(rho,1000); } 
	else {nx=6;ny=2;}
	nt=nx+ny-2;

	decl alt=(ny==2)? 4.0 : 3.0;
	PTswitchcv=6;
	decl altrange=9;
	thaltlist=range(-altrange,altrange-2,2)|range(-altrange+2,altrange,2)|alt;
	malt=columns(thaltlist);

	grid0=(range(-25,24)/2)|(range(-24,25)/2);
	grid1=(-altrange+(range(-5,-1)|range(-4,0))/2)|alt;
	grid1~=(altrange+(range(0,4)|range(1,5))/2)|alt;
	decl N1=columns(grid1);
	grid1alt=new array[N1];
	for(decl i=0;i<N1;i++)
		grid1alt[i]=grid1[][i]; 

	p_level=1-probt(quant(1-level/2,nx-1),nx-1,alt)+probt(-quant(1-level/2,ny-1),nx-1,alt)
		~(1-probt(quant(1-level/2,ny-1),ny-1,alt)+probt(-quant(1-level/2,ny-1),ny-1,alt));
	p_level=p_level**ones(1,N1/2);

	chkgrid0=grid0[0][]~meanc(grid0);
	chkgrid0|=chkgrid0+.01;
	

	fdellist=range(-20,20)'/2;
	fdellist~=fdellist+.01;
	fblist=<0;1.5;3;4.5;6>;

	nalt=100000;
	n0=20000;

	seteps=setepsBF;mkY=mkYBF;setlogh=setloghBF;getLR0=getLR0BF;getLR1=getLR1BF;getpowerbench=getpowerbenchBF;

	if(nx==ny){
		thaltlist=range(0,altrange-3,3)|range(3,altrange,3)|(alt);
		malt=columns(thaltlist);

		grid0=(range(0,24)/2)|(range(1,25)/2);
		grid1=(altrange+(range(0,4)|range(1,5))/2)|alt;
		N1=columns(grid1);
		grid1alt=new array[N1];
		for(decl i=0;i<N1;i++)
		grid1alt[i]=grid1[][i]; 

		p_level=1-probt(quant(1-level/2,nx-1),nx-1,alt)+probt(-quant(1-level/2,ny-1),nx-1,alt);
		p_level=p_level**ones(1,N1);

		chkgrid0=grid0[0][]~meanc(grid0);
		chkgrid0|=chkgrid0+.01;

		fblist=<0;2;4;6;8>;
	}
	

}

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXX  LTUd: LTU regressor discrete grid XXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

const decl T=1000;

setepsLTUd()
{
	eps=rann(T,n+1);
}

LTUd_bs(const c)
{
	return (c.>=0) .? sqrt((2*c+6)/(1-rho^2)) .: sqrt(6*exp(c)/(1-rho^2));
}

decl YPT;

mkYLTUd(const theta)
{
	decl b,c;
	if(columns(theta)==1){
		c=theta[0];
		b=theta[2]*LTUd_bs(c);
	}
	else
	{
		decl m=columns(theta);
		b=c=zeros(1,n);
		for(decl i=0;i<m;i++){
			c[n*i/m:n*(i+1)/m-1]=theta[0][i];
			b[n*i/m:n*(i+1)/m-1]=theta[2][i]*LTUd_bs(theta[0][i]);
		}			
	}	
		
	decl r=1-c/T;
	decl Wx=0|cumsum(eps[][1:],r')/sqrt(T);
	decl Wxmu=Wx[0:T-1][]-meanc(Wx[0:T-1][]);
	Y=(sumc(Wxmu.*eps[][0:n-1])/sqrt(T))|(sumc(Wx[0:T-1][].*(Wx[1:T][]-Wx[0:T-1][])))
				|(sumsqrc(Wxmu)/T)|(sumsqrc(Wx[0:T-1][])/T);

	Y[0][]+=(b+c*rho/sqrt(1-rho^2)).*Y[2][];
	Y[1][]-=(rho/sqrt(1-rho^2))*Y[0][];
	decl delhat=-(Y[1][]+(rho/sqrt(1-rho^2))*Y[0][])./Y[3][];
	
	YPT=Y[0][]./Y[2][]-(rho/sqrt(1-rho^2))*delhat;
	YPT./=sqrt(1 ./ Y[2][]+(rho^2/(1-rho^2))./Y[3][]);
}

setloghLTUd()
{
	decl loghv=zeros(malt,n);
	for(decl i=0;i<malt;i++){
		decl c=thaltlist[0][i];
		decl b=thaltlist[2][i]*LTUd_bs(c);
		loghv[i][]=b*Y[0][]-c*Y[1][]-.5*(b+c*rho/sqrt(1-rho^2))^2*Y[2][]-.5*c^2*Y[3][];
	}
	logh=maxc(loghv);
	logh+=log(meanc(exp(loghv-logh)));

	LANtest=YPT.>((rho<0)?1.70:quann(0.95));
	swtch=(-(Y[1][]+(rho/sqrt(1-rho^2))*Y[0][])./Y[3][] .> PTswitchcv) .? -1E300+2E300*LANtest .:0;
}

getLR0LTUd(const theta)
{
	decl c=theta[0];
	return -c*Y[1][]-.5*(c*rho/sqrt(1-rho^2))^2*Y[2][]-.5*c^2*Y[3][];
}

getLR1LTUd(const theta)
{
	decl c=theta[0];
	decl b=theta[2]*LTUd_bs(c);
	return b*Y[0][]-c*Y[1][]-.5*(b+c*rho/sqrt(1-rho^2))^2*Y[2][]-.5*c^2*Y[3][];
}


getpowerbenchLTUd()
{
	return 0; 
}

setupLTUd()
{
	decl balt=1.645;
	decl stepsize=.2;
	grid0=sqr(range(0,14,.25));
	grid0|=grid0[1:]~(14.50^2);

	chkgrid0=sortr(grid0[0][]~meanc(grid0));
	chkgrid0|=chkgrid0;
	
	stepsize=5;
	grid1=(160+(range(0,30,stepsize)|range(stepsize,30+stepsize,stepsize)))|balt;
 	decl del1=meanc(grid1[0:1][]);
	p_level=0.50;

	N0=columns(grid0);
	N1=columns(grid1);
	N=N0+N1;
	grid1alt=new array[N1];
	for(decl i=0;i<N1;i++)
		grid1alt[i]=grid1[][i];

	thaltlist=selectifc(grid0,grid0.<=160)|balt;
	malt=columns(thaltlist);

	fdellist=grid0[0][range(0,columns(grid0)-1,4)]';
	fdellist~=fdellist;
	fblist=<0;1;2;3;4>;

	nalt=100000;
	n0=20000;

	seteps=setepsLTUd;mkY=mkYLTUd;setlogh=setloghLTUd;getLR0=getLR0LTUd;getLR1=getLR1LTUd;getpowerbench=getpowerbenchLTUd;

	PTswitchcv=130;
}


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXX  BD: Break Date  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

const decl BDco=.15;
const decl BDaltsig=10;
const decl BDaltdel=20;
decl G;

setepsBD()
{
	eps=rann(T,n);
	deleps=ranu(1,n);
}

decl EM;
mkYBD(const theta)
{
	G=eps;
	decl BDt0=BDco*T;
	decl BDt1=(1-BDco)*T;
	if(theta[2]==-1) {
		for(decl i=0;i<n;i++) {
			decl p=probn(-BDaltdel/BDaltsig);
			G[BDt0+T*(1-2*BDco)*deleps[i]:][i]+=BDaltsig*quann(p+(1-2*p)*ranu(1,1))/sqrt(T);
			}
	}
	else {
		if (theta[2]==0) G[rho*T:][]+=(theta[0]+(theta[1]-theta[0])*deleps)/sqrt(T);
		else G[theta[0]*T:][]+=theta[2]/sqrt(T);
	}

	EM=<>;
	if(theta[2]!=0) EM=sumsqrc(cumulate(G[0:rho*T-1][]-meanc(G[0:rho*T-1][])))/(rho*T)^2+
						sumsqrc(cumulate(G[rho*T:][]-meanc(G[rho*T:][])))/((1-rho)*T)^2;
	G-=meanc(G);
	G=cumulate(G)[BDt0:BDt1][]/sqrt(T);

	Y=G[rho*T-BDt0][];
}

setloghBD()
{
	decl BDt0=BDco*T;
	decl BDt1=(1-BDco)*T;

	decl s1ms=(range(0,T-1)+.5)'/T;
	s1ms=(s1ms.*(1-s1ms))[BDt0:BDt1];
	decl c=sqrt(s1ms+1/BDaltsig^2);

	decl loghv=zeros(malt,n);
	for(decl i=0;i<malt;i++){
		decl p=probn(-BDaltdel/BDaltsig);
		for(decl j=0;j<n;j++){
			decl Gs=G[][j]./c;
			loghv[i][j]=log(meanc(exp(.5*sqr(Gs)+logprobn(-BDaltdel*c-Gs,BDaltdel*c-Gs))./(c*BDaltsig*(1-2*p))));
			if(imod(j,1000)==0) print("x");
		}
	}
	logh=maxc(loghv);
	logh+=log(meanc(exp(loghv-logh)));

	swtch=LANtest=zeros(1,n);
}


getLR0BD(const th)
{
	decl del=th;
	decl g=zeros(2,n);

	decl a=rho*(1-rho);
	decl a0=(a*del[0]-Y[0][])/sqrt(a);
	decl a1=(a*del[1]-Y[0][])/sqrt(a);

	g[0][]=.5*sqr(Y[0][])/a+0.5*log(2*M_PI/a)
			+logprobn(a0,a1)-log(del[1]-del[0]);
	del=-reversec(del);
	a0=(a*del[0]-Y[0][])/sqrt(a);
	a1=(a*del[1]-Y[0][])/sqrt(a);
	g[1][]=.5*sqr(Y[0][])/a+0.5*log(2*M_PI/a)
			+logprobn(a0,a1)-log(del[1]-del[0]);
	
	decl gmax=maxc(g);
	return gmax+log(meanc(exp(g-gmax)));
}

getLR1BD(const theta)
{
	print("call to getLR1BD"); exit(0);
}


getpowerbenchBD()
{
	return EM.>0.745; 
}

setupBD()
{
	thaltlist=<	20,0,-1>';
	malt=columns(thaltlist);

	grid0=range(0,19,1)|range(1,20,1);
	chkgrid0=sortr(grid0[0][]~meanc(grid0[0:1][]));	
	chkgrid0|=(chkgrid0+.01);
	
	grid1=<>;
	grid1alt=new array[0];

	fdellist=0.15+range(0,28)'/40;
	fdellist~=fdellist+.01;
	fblist=<.001;4;8;12;16>;
	p_level=.NaN;

	BO_FLAG=FALSE;
	seteps=setepsBD;mkY=mkYBD;setlogh=setloghBD;getLR0=getLR0BD;getLR1=getLR1BD;getpowerbench=getpowerbenchBD;

	nalt=40000;
	n0=20000;

}



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXX  RS: Regressor Selection XXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

setepsRS()
{
	eps=choleski((1~rho)|(rho~1))*rann(2,n);
	Sigi=invertsym((1~rho)|(rho~1));
}

mkYRS(const thlist)
{
	Y=eps;
	decl m=columns(thlist);
	for(decl i=0;i<m;i++){
		decl del=thlist[0:1][i];
		Y[][n*i/m:n*(i+1)/m-1]+=thlist[2][i]|del[0];
	}
}

setloghRS()
{
	decl loghv=zeros(malt,n);
	for(decl i=0;i<malt;i++){
		decl Yx=Y;
		Yx[0][]-=thaltlist[2][i];
		loghv[i][]=-.5*sumc(Yx.*(Sigi*Yx));
	}
	logh=maxc(loghv);
	logh+=log(meanc(exp(loghv-logh)));
	LANtest=fabs(Y[0][]).>quann(1-level/2);
	swtch=(fabs(Y[1][]).>PTswitchcv) .?  -1E300+2E300*LANtest .:0;
}


getLR0RS(const del)
{
	decl Yx=Y;
	decl g=zeros(2,n);
	Yx[1][]-=del;
	g[0][]=-.5*sumc(Yx.*(Sigi*Yx));
	Yx[1][]+=2*del;
	g[1][]=-.5*sumc(Yx.*(Sigi*Yx));
	
	decl gmax=maxc(g);
	return gmax+log(meanc(exp(g-gmax)));
}

getLR1RS(const theta)
{
	print("call to getLR1RS"); exit(0);
	
}

getpowerbenchRS()
{
	return fabs(Y[0][]).>quann(0.975);
}

setupRS()
{
	grid0=range(0,45)/5;
	grid0|=grid0+.2;

	chkgrid0=sortr(grid0[0][]~meanc(grid0));	
	chkgrid0|=chkgrid0+.01;
	grid1=<>;
	BO_FLAG=FALSE;

	b1s=<-2,2>;
	thaltlist=<0,0;0,0>|b1s;
	malt=columns(thaltlist);
	


	fdellist=range(0,48)'/4;
	fdellist~=fdellist+.01;
	fblist=<-1;-2;-3;-4;0;1;2;3;4>;

	nalt=100000;
	n0=20000;

	PTswitchcv=6;

	seteps=setepsRS;mkY=mkYRS;setlogh=setloghRS;getLR0=getLR0RS;getLR1=getLR1RS;getpowerbench=getpowerbenchRS;
	
}


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXX  General Part of Program  XXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


main()
{
	format(5000);

// select which test to compute 
	
//	setupPN();
//	setupIM();
//	setupBF();
	setupLTUd();
//	setupBD();
//	setupRS();
	
	println("Starting computations for ",sprint(mkY)[3:4]);

	decl FIGUREFLAG=FALSE;
	N0=columns(grid0);
	N1=columns(grid1);
	N=N0+N1;

	decl lamsout=.NaN~grid0;
	decl statsout=<>;
	decl Nso={};

// rholist contains list of known parameter of tests to compute, format varies across tests
	decl rholist;

	rholist=range(0,.8,0.05)~range(0.85,.98,.01);	// for PN, IM, LTU, RS
	rholist=rholist~(-rholist); 					// for LTU, comment out otherwise
		
//	rholist=(range(2,12,1)*1000+2)~(range(3,12,1)*1000+3); // for BF

//	rholist=range(.15,.50,.01);						// for BD


	decl rhon=columns(rholist);	
	for(decl rc=0;rc<rhon;rc++){
	rho=rholist[rc];

	if(rho>1000) {
		setupBF();
		N0=columns(grid0);
		N1=columns(grid1);
		N=N0+N1;
	}

	decl cstatsout=rho;
	Nso~={"rho"};


	println("rho ",rho,getLR0);
	decl LR0,LR1,LR0c,LR1c;
	LR0=LR1=LR0c=new array[N+1];
	decl LR0m,LR1m,SW,L_t,b_t,LR0t,LR1t;
	LR0m=LR1m=SW=L_t=LR0t=LR1t=LR0;
	decl N0c=columns(chkgrid0);
	ranseed(16);
	n=n0;
	for(decl i=0;i<N+1;i++){
		if(i==N) {n=nalt;  seteps(); mkY(thaltlist);}
		else{
			seteps();

			if(i<N0)
				mkY(grid0[][i]|0);
			else
				mkY(grid1alt[i-N0]);
			}
		setlogh();
		SW[i]=swtch;
		L_t[i]=LANtest;
		
		LR0[i]=zeros(N0,n);
		LR1[i]=zeros(N1,n);

		for(decl j=0;j<N0;j++)
			LR0[i][j][]=getLR0(grid0[][j]);
		for(decl j=0;j<N1;j++)
			LR1[i][j][]=getLR1(grid1[][j]);

		LR0t[i]=exp(setbounds(LR0[i]-logh,-500,500));
		decl LR0max=maxc(LR0[i]);
		LR0[i]=exp(LR0[i]-LR0max);
		LR0m[i]=sumc(LR0[i]);					
		
		LR1t[i]=exp(setbounds(LR1[i]-logh,-500,500));
		decl LR1max=maxc(LR1[i]);
		LR1[i]=exp(LR1[i]-LR1max);
		LR1m[i]=sumc(LR1[i]);					
		

		LR0c[i]=zeros(N0c,n);
		for(decl j=0;j<N0c;j++)
			LR0c[i][j][]=exp(getLR0(chkgrid0[][j])-LR0max);

	}

	println("done precomputing");
	decl RP0x=zeros(N0,1);
	for(decl i=0;i<N0;i++)
		RP0x+=meanr((SW[i] .>0).*(LR0[i]./LR0m[i]));
	print("RP of pure switching test",grid0|RP0x');
	decl switchlevel=maxc(RP0x'|level);
	if(!BO_FLAG) goto label_besttest;

	if(max(switchlevel)>level+.0015) println("Switching induces overrejections!",max(switchlevel) );

	decl RP1x=zeros(N1,1);
	decl RP1x2=zeros(N1,1);
	for(decl i=N0;i<N;i++){
		RP1x+=meanr((L_t[i] .>0).*(LR1[i]./LR1m[i]));
		RP1x2+=meanr((SW[i] .>0).*(LR1[i]./LR1m[i]));
	}
	decl ep_level=RP1x2';
	print("power of LAN test on grid1",grid1|ep_level|p_level);
	if(max(RP1x-RP1x2)>.005) println("Switching does not induce LANtest power!",max(RP1x-RP1x2) );
	cstatsout~=max(RP1x-RP1x2)~max(p_level-ep_level);	
	Nso~={"LAN - SW","p_level-SW"};

// Done precomputing LRs	
// Now find best switchting test
:label_besttest

	decl lam0,lam1;
	decl RP0,RP1,nu0,nu1;
	lam0=-2*ones(1,N0);
	
	for(decl lc=0;lc<=600;lc++){
		nu0=exp(lam0);
		RP0=zeros(N0,1);
		for(decl i=0;i<N0;i++)
			RP0+=meanr((1+SW[i] .> nu0*LR0t[i]).*(LR0[i]./LR0m[i]));
		lam0+=2*(RP0'-switchlevel);
	}
	print("RP0 and power of test with switching, unrefined");
	print(grid0|RP0'|nu0,nu0*RP0/sumr(nu0),meanr(1+SW[N] .>nu0*LR0t[N]));
// for powerbound conditional on switching, make sure average null RP is exactly 5%
	decl nu0f=1.0;
	decl RP0g;
	for(decl lc=0;lc<=100;lc++){
		RP0g=zeros(N0,1);
		for(decl i=0;i<N0;i++)
			RP0g+=meanr((1+SW[i] .> nu0f*nu0*LR0t[i]).*(LR0[i]./LR0m[i]));
		nu0f=nu0f*exp(1*(nu0*RP0g/sumr(nu0)-level));
	}

// powerbound conditional on switching	
	decl pi1x=meanr(1+SW[N] .>nu0f*nu0*LR0t[N]);

	print("power bound conditional on switchting", pi1x);

// scale up nu0 s.t. power is equal to bound - .5%
	decl lamfac=1.0, lamfdel=.5;
	for(decl i=0;i<12;i++){
		if(meanr(1+SW[N] .>lamfac*nu0*LR0t[N])>pi1x-.005) lamfac+=lamfdel;
		else lamfac-=lamfdel;
		lamfdel*=0.5;
	}

	print("power of potential feasible test",meanr(1+SW[N] .>lamfac*nu0*LR0t[N])~lamfac);
	nu0*=lamfac;
	lamsout|=rho~nu0;
// now check whether it controls size
	decl chkRP=zeros(N0c,1);
	decl chkRP2=chkRP;
	for(decl i=0;i<N0;i++){
		chkRP+=meanr((1+SW[i] .> nu0*LR0t[i]).*(LR0c[i]./LR0m[i]));
		chkRP2+=sumsqrr(N0*(1+SW[i] .> nu0*LR0t[i]).*(LR0c[i]./LR0m[i]));
		}
	chkRP2=sqrt((chkRP2/(N0*columns(SW[0]))-sqr(chkRP))/(N0*columns(SW[0])));
	print("Size check of feasible test",chkgrid0|chkRP'|chkRP2');
	println("Largest Standard Error:", max(chkRP2));

	cstatsout~=chkgrid0[0][maxcindex(chkRP)]~max(chkRP)~max((chkRP-level)./chkRP2)~max(chkRP2);
	Nso~={"wrst del0","lgst RPc","RPc t-stat","lgst stdev"};
	if(max((chkRP-level)./chkRP2)>2){
	println("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n",
			"XXXXXXXXX  Test Overrejects XXXXXXXXXXXXXXXXXXX\n",
			"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n",
		max(chkRP));}

// now compute power picture numbers

	if(FIGUREFLAG){
// create file with test properties to be read by Mathematica for picture creation
		decl filename=sprint("R2testdata",sprint(mkY)[3:4],100*rho,".dat");
		decl outfile=fopen(filename,"w");
		fclose(outfile);
		outfile=fopen(filename,"la");
	
		print(rho~PTswitchcv~rows(fblist)~nx~ny~rows(grid0));
		print(fblist');
		print(thaltlist,nu0|grid0);
		print(fdellist[][0]');
	
		n=20000;
		seteps();
		for(decl bi=0;bi<rows(fblist);bi++){
			decl power=<>;
			decl bpower=power;
			for(decl ci=0;ci<rows(fdellist);ci++){
				mkY((fdellist[ci][]')|fblist[bi]);
				setlogh();
				decl LRg=zeros(N0,n);
				for(decl j=0;j<N0;j++)
					LRg[j][]=exp(setbounds(getLR0(grid0[][j])-logh,-500,500));
				power~=meanr(1+swtch .>nu0*LRg);
				bpower~=meanr(getpowerbench());
			}	
			print(fblist[bi]);
			print(power|bpower);
		}
		fclose("l");
	}

	cstatsout~=(pi1x-.005);
	Nso~={"WAP fsbl"};
	if(!BO_FLAG) goto label_summary;
	
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// XXXXXXXXXXXXXX  Compute power bound under power constraint XXXXXXXXXXXXXXXXX
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

	lam1=-2*ones(1,N1);
	lam0=-2*ones(1,N0);
	for(decl lc=0;lc<=600;lc++){
		nu0=exp(lam0);
		nu1=exp(lam1);
		RP0=zeros(N0,1);
		for(decl i=0;i<N0;i++)
			RP0+=meanr((1+nu1*LR1t[i].>nu0*LR0t[i]).*(LR0[i]./LR0m[i]));
		RP1=zeros(N1,1);
		for(decl i=N0;i<N;i++)
			RP1+=meanr((1+nu1*LR1t[i].>nu0*LR0t[i]).*(LR1[i]./LR1m[i]));
		lam0+=2*(RP0'-level);
		lam1+=.5*(ep_level-RP1');
	}	
	nu0=exp(lam0);
	nu1=exp(lam1);
	print("unrefined power bound with power constraint",meanr(1+nu1*LR1t[N].>nu0*LR0t[N]),grid0|RP0'|nu0,grid1|RP1'|nu1);

	decl p_levelg=sumr(nu1.*ep_level)/sumr(nu1);
	print("nu1 average power over grid1 ",p_levelg);
// first drop power constraint and find test that rejects exactly 5% under null
	nu0f=1.0;
	for(decl lc=0;lc<=100;lc++){
		RP0g=zeros(N0,1);
		for(decl i=0;i<N0;i++)
			RP0g+=meanr((1 .>nu0f*nu0*LR0t[i]).*(LR0[i]./LR0m[i]));
		nu0f=nu0f*exp(1*(nu0*RP0g/sumr(nu0)-level));
	}

	decl RP1g=zeros(N1,1);
	for(decl i=N0;i<N;i++)
		RP1g+=meanr((1 .>nu0f*nu0*LR0t[i]).*(LR1[i]./LR1m[i]));
		
	decl pi1;
	if(nu1*RP1g/sumr(nu1)>p_levelg){
		println("Alternative constraint not binding; dropping constraint from power bound calculation");
		print("nu0-average RP0 without power constraint",nu0*RP0g/sumr(nu0),nu0f); 
		pi1=meanr(1 .>nu0f*nu0*LR0t[N]);
		print("powerbound is",pi1~pi1x);
	}
// now compute power bound with power constraint

	else {
	decl nu1f=1.0;
	nu0f=1.0;

	for(decl lc=0;lc<=100;lc++){
		RP0g=zeros(N0,1);
		for(decl i=0;i<N0;i++)
			RP0g+=meanr((1+nu1f*nu1*LR1t[i] .>nu0f*nu0*LR0t[i]).*(LR0[i]./LR0m[i]));
		RP1g=zeros(N1,1);
		for(decl i=N0;i<N;i++)
			RP1g+=meanr((1+nu1f*nu1*LR1t[i].>nu0f*nu0*LR0t[i]).*(LR1[i]./LR1m[i]));
		nu0f=nu0f*exp(.05*(nu0*RP0g/sumr(nu0)-level));
		nu1f=nu1f*exp(-.05*(nu1*RP1g/sumr(nu1)-p_levelg));
	}
	print(nu0f,nu1f,RP0g',RP1g');
	pi1=meanr(1+nu1f*nu1*LR1t[N].>nu0f*nu0*LR0t[N]);
	print("powerbound is",pi1~(pi1x-.005));
	}
	cstatsout~=pi1~(pi1-(pi1x-.005));
	Nso~={"WAP bound", "pow diff"};

:label_summary
	statsout|=cstatsout;

	println("OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO");
	println("OOOOOOOOOOOOOOOOOOOOOOOO Summary OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO");
	println("OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO");

	println("current test ",getLR0," with rho=",rho);
	println("null RPs",chkgrid0|chkRP',max(chkRP));

	println("%c",Nso,statsout);

	decl filename=sprint("lambda_",sprint(mkY)[3:4],".dat");
	decl outfile=fopen(filename,"l");
	println("all lambdas",lamsout,"\n\n\n\n\n\n");
	fclose("l");

	}
	
}
	