% MC program for the Behrens Fisher example

% CHOICE VARIABLES FOR THE MONTE CARLO SETUP

nmc=3000;           % number of Monte Carlo rejections


s=8840572;           % seed

% choice parameters

% models are parameter choices. We set the mean of x2 =0 and variance of x2 to be one
% first column:    beta
% second column:   delta
% third column:    n1
% fourth column:   n2

models= [0*ones(21,1) (-10:1:10)' 3*ones(21,1) 3*ones(21,1)];
nm=length(models);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Should not need to change anything below here

sout=zeros(nm,2);
for im=1:(nm);



rng(s);
mcout=zeros(nmc,2);
for imc=1:nmc;
    
    % generate data
    sig1=exp(models(im,2));
    mu1=models(im,1)*sqrt(sig1*sig1/models(im,3)+1/models(im,4));
    x1=randn(models(im,3),1)*sig1+mu1*ones(models(im,3),1);
    x2=randn(models(im,4),1);
    
    % undertake test
    [mcout(imc,1),mcout(imc,2)] = BehrensFisher(x1,x2);
        
end;


sout(im,1)=mean(mcout(:,1));
sout(im,2)=mean(mcout(:,2));
end;

[models(1:nm,:) sout]
    
    
    
