% program to run MC to check Figure 7 results

nmc=10000;

rho=(0:0.05:0.98)';  %   Values for rho
bv=2;                % values for beta
gv=0;                % values for delta
 
s=8840572;           % seed




sout=zeros(length(rho),2);
for ib=1:length(rho);

sig=eye(2);
sig(1,2)=rho(ib,1);
sig(2,1)=rho(ib,1);
    
rng(s);
mcout=zeros(nmc,2);
for imc=1:nmc;

% pseudeo data generation
eps=chol(sig)'*randn(2,1);
x=eps(1,1)+bv;
y=eps(2,1)+gv;


% run LFAV test 
[rejf] = regsel1(x,y,rho(ib,1));
mcout(imc,1)=rejf;





% just include the additional variable
   tst=(x*x);
   mcout(imc,2)=tst>3.84;



end;

sout(ib,1)=mean(mcout(:,1));
sout(ib,2)=mean(mcout(:,2));



end;


plot(rho,sout)