% MC program to evaluate the Stoye confidence intervals
clear all;


% CHOICE VARIABLES FOR THE MONTE CARLO SETUP

nmc=50000;           % number of Monte Carlo rejections

% choice parameters

% models are parameter choices
% first column:    beta  (i.e. distance to zero of interval
% second column:   delta (i.e. the length of the interval)
% third column :   rho   (i.e correlation between upper and lower)
models=[0*ones(19,1) 0.5*ones(19,1) (0.075:0.05:0.975)'];



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Should not need to change anything below here

sig=eye(2);
sd=439643;

sout=zeros(length(models),1);
for im=1:length(models);
    
thet0=models(im,1);             % true value for beta
d=models(im,2);                 % distance 
sig(1,2)=models(im,3);             % correlation
sig(2,1)=sig(1,2);


% construct means 
thetl=thet0;               % lower bound
thetu=thetl+d;             % upper bound


mcout=zeros(nmc,1);
rng(sd);
for imc=1:nmc;
    
    % psuedo data generation
    eps=chol(sig)'*randn(2,1);
    x=eps(1,1)+thetl;
    y=eps(2,1)+thetu;
    
    % construct LFAV test 
    [mcout(imc,1)] = imbman(x,y,models(im,3));
    
end;

sout(im,1)=mean(mcout);

end;

[models sout]


    
 
