% Program to examine the Pretest example 

% CHOICE VARIABLES FOR THE MONTE CARLO SETUP

nmc=50000;           % number of Monte Carlo rejections
s=8840572;           % seed

% choice parameters



% models are parameter choices
% first column:    beta  (i.e. mean of variable we test)
% second column:   delta (i.e. mean of additional variable)
% third column :   rho  (i.e correlation between variables)
models=[0*ones(19,1) 2*ones(19,1) (0.075:0.05:0.975)' ];



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Should not need to change anything below here



sout=zeros(length(models),2);
for ib=1:length(models);

sig=eye(2);
sig(1,2)=models(ib,3);
sig(2,1)=sig(1,2);
    
rng(s);
mcout=zeros(nmc,2);
for imc=1:nmc;

% pseudeo data generation
eps=chol(sig)'*randn(2,1);
x=eps(1,1)+models(ib,1);
y=eps(2,1)+models(ib,2);

% run LFAV test 
[rejf] = regsel1(x,y,models(ib,3));
mcout(imc,1)=rejf;

% just include the additional variable
mcout(imc,2)=(x*x)>3.84;

end;

sout(ib,1)=mean(mcout(:,1));
sout(ib,2)=mean(mcout(:,2));



end;


[models sout]