function [q] = bffn(t,r,beta,delta,n1,n2);

% common terms under H0 and HA
w=exp(delta);
t1=((n1-1)^(n1/2))*((n2-1)^(n2/2))*w./(r.*r*gamma(0.5+n1/2)*gamma(0.5+n2/2));
t5a=n1+n2*w.*w;
t2=sqrt(n1*n2./(pi*t5a));
eta=beta*sqrt(t5a/(n1*n2));

t3=((r./w).^n1);
n=n1+n2-2;
t4=n2*w.*w*(1+r.*r+t.*t)-w.*w-r.*r;
t5=w.*w.*t5a;
c2=((n2-1)*n2*(w.^4)+n1*n1*r.*r-n2*w.*w*r.*r+n1*t4)./t5;
c=sqrt(c2);

if eta==0;
   
 % for the null
bb=(c.^(-(n+1)))*gamma(0.5+n/2)*(2^(n/2-0.5));
q=(2^(0.5-n1/2-n2/2))*bb.*t1.*t2.*t3.*sqrt((n1-1)*(n2-1));


else;
    

    % for the alternative 
t3a=exp(-0.5*eta.*eta*n1*n2./t5a);
d=eta*n1*n2*t./t5a;
h=d./c;
h1=h./(abs(h));
[d1,d2]=size(r);
sl=zeros(d1,d2);
for l=0:n;
    g1=gamma((1+l)/2);
    g1i=gammainc(h.*h/2,(1+l)/2);
    h1l=h1.^(l+1); 
    ilh=(2^(l/2-0.5))*(((-1)^l)*g1+h1l.*g1.*g1i);
    sl=sl+nchoosek(n,l)*((-(1./h)).^l).*ilh;
end;


q=(2^(0.5-n1/2-n2/2))*t1.*t2.*t3.*t3a.*exp(0.5*h.*h).*((d.^n)./((c).^(2*n+1))).*(sl)*sqrt((n1-1)*(n2-1));


end;

