% MC program for the break date example

% CHOICE VARIABLES FOR THE MONTE CARLO SETUP

nmc=50000;           % number of Monte Carlo rejections
nobs=1000;           % number of steps in the Brownian Motion approximations

s=8840572;           % seed

% choice parameters

% models are parameter choices
% first column:    beta0  (i.e. break date proportion for H0)
% second column:   delta (i.e. size of break )
% third column:    beta-beta0 (i.e. beta is the true break date proportion)

%models= [(0.15:0.05:0.45)' 5*ones(7,1) 0*ones(7,1)];   % size
models= [0.2*ones(3,1) 4*ones(3,1) (0.25:0.1:0.45)'];

nm=length(models);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Should not need to change anything below here

sout=zeros(nm,1);
for im=1:nm;


b0=models(im,1);
delta=models(im,2);     % delta
beta=b0+models(im,3);


mcout=zeros(nmc,1);
bd=round(beta*100)*nobs/100;
rng(s);

for imc=1:nmc;
    
    % generate data
    bp=[zeros(bd-1,1); ones(nobs-bd+1,1)];
    y=(delta/sqrt(nobs))*bp+randn(nobs,1);
    
    
    % undertake test
    [mcout(imc,1)] = breakdate(y,b0);
        
end;


sout(im,1)=mean(mcout);

end;

[models sout]
    
    
    
