%   5/92 proc to lookup and interpolate critical values from
%     a matrix.  Takes test stat value and matrix as arguments
%     and lineraly interpolates down first column, returning
%     entire sequence (ie interpolated row) of critical values
%     Note: cvm(:,1) must be in ascending order!
%
%     Input :  xs  -  value of test statistic
%              cvm -  critical value matrix where column one
%                     contains values of xs and subsequent
%                     columns critical values for various size
%
%     Output:  cv  -  interpolated row of critical values


function [cv] = crlk(xs,cvm);

 [nr,nc]=size(cvm);
% ----- work out between which rows xs occurs -----------@
 if xs<cvm(1,1); cv=cvm(1,2:nc);
   elseif  xs>cvm(nr,1); cv=cvm(nr,2:nc);
   else;
   [jnk,rn]=min(abs(xs*ones(nr,1)-(cvm(:,1))));
   if xs>cvm(rn,1); rl=rn; else; rl=rn-1 ; end;


% ------ do the interpolation ---------------------------@

   if xs==cvm(rn,1); cv=cvm(rn,2:nc);
     else;
     sc=(xs-cvm(rl,1))/(cvm(rl+1,1)-cvm(rl,1));
     cv=cvm(rl,2:nc)+sc*(cvm(rl+1,2:nc)-cvm(rl,2:nc));
   end;

   end;

