% program to run MC to check size and power of the running example

% CHOICE VARIABLES FOR THE MONTE CARLO SETUP

nmc=10000;           % number of Monte Carlo rejections
s=8840572;           % seed

% choice parameters

rho=0.5;             % correlation between variables

% models are parameter choices
% first column:    beta  (i.e. mean of variable we test)
% second column:   delta (i.e. mean of additional variable)
models=[0*ones(4,1) (1:1:4)'];



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Should not need to change anything below here

sig=eye(2);
sig(1,2)=rho;
sig(2,1)=rho;

isig=inv(sig);

sout=zeros(length(models),2);
for ib=1:length(models);


    
rng(s);
mcout=zeros(nmc,2);
for imc=1:nmc;

% pseudeo data generation
eps=chol(sig)'*randn(2,1);
x=eps(1,1)+models(ib,1);
y=eps(2,1)+models(ib,2);

% run test
[mcout(imc,1)]=runnex(x,y,rho);


% just include the additional variable
tst=(x*x);
mcout(imc,2)=tst>3.84;

end;

sout(ib,1)=mean(mcout(:,1));
sout(ib,2)=mean(mcout(:,2));

end;


% table of results
[models sout]