% MC program to evaluate the prediction problem example
clear all;


% CHOICE VARIABLES FOR THE MONTE CARLO SETUP

nmc=10000;           % number of Monte Carlo rejections
nobs=1000;           % number of steps in the Brownian Motion approximations
% choice parameters


% models are parameter choices
% first column:    beta  (i.e. coefficient on lagged variable to be tested)
% second column:   rho   (i.e. the correlation between the shocks)
models=[0*ones(10,1) (-0.9:0.2:0.9)'];

delta=(0:5:30)';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Should not need to change anything below here
     
s=53756;        
[l1,junk]=size(models);
sout=zeros(l1,length(delta));
for ic=1:length(delta);


r=1-delta(ic,1)/nobs;
delt=delta(ic,1);

mcout=zeros(nmc,l1);mcout1=mcout;mcout2=mcout;
rng(s);
for imc=1:nmc;

% construct the steps approximation to the limiting distribution of the
% stochastic components.

eps=randn(nobs,2);
jcr1c=recserar(eps(:,2),0,r);
jcr1=[0;jcr1c(1:nobs-1,1)]; 
jcr1m=jcr1-mean(jcr1c);
dwx=-delt*jcr1/(nobs)+eps(:,2);

y4=(jcr1'*jcr1)/(nobs*nobs);
y3=(jcr1m'*jcr1m)/(nobs*nobs);
y1a=(jcr1m'*eps(:,1))/(nobs);
y2a=(jcr1'*dwx)/(nobs);


% construct the statistic for each of the pairs in models
for im=1:l1;
    
    % Our statistic
    rho=models(im,2);
    r1=rho/sqrt(1-rho*rho);
    beta=models(im,1)*sqrt((2*delt+6)/(1-rho*rho));
    y1=y1a+(beta+r1*delt)*y3;
    y2=y2a-r1*y1;
    mcout(imc,im) = predreg1side(y1,y2,y3,y4,rho);
    
    
    
  
end;

end;


sout(:,ic)=mean(mcout)';


end;
delta'
[models sout ]



